unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TLeastenThread=class(TThread)
  private
   buf_out:string;
   buf_in:string;
  protected
   procedure Execute; override;
   procedure DoMemoOut;
   procedure DoMemoIn;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  FChildStdoutRd, FChildStdoutWr, FChildStdinRd, FChildStdinWr:THandle;
  Tmp1, Tmp2, hStdout:THandle;
  sa:TSecurityAttributes;
  hProcess:THandle;
  flag_enter:boolean;
  LeastenThread:TLeastenThread;


function CreateChildProcess(command:string; var hPr:THandle):boolean;
var
  ProcInf: TProcessInformation;
  StartInf: TStartupInfo;
begin
 Result:=False;
 ZeroMemory(@ProcInf, sizeof(TProcessInformation));
 ZeroMemory(@StartInf, sizeof(TStartupInfo));
 StartInf.cb:=sizeof(TStartupInfo);
 StartInf.hStdError:=FChildStdoutWr;
 StartInf.hStdOutput:=FChildStdoutWr;
 StartInf.hStdInput:=FChildStdinRd;
 StartInf.dwFlags:=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
 StartInf.wShowWindow:=SW_HIDE;

 If not CreateProcess(nil, PChar(command), nil,
  nil, True, 0, nil, nil, StartInf, ProcInf) then
 begin
  MessageBox(0, 'CreateProcess failed', '', MB_OK or MB_ICONERROR);
  Result:=False;
  exit;
 end;
 hPr:=ProcInf.hProcess;
 Result:=True;
end;

function WriteToChild(Data: string; Timeout: Integer = 1000): Boolean;
var
  dwWritten, BufSize: DWORD;
  chBuf: PChar;
begin
 chBuf:=PChar(Data + Chr($0D) + Chr($0A));
 BufSize:=Length(chBuf);
 Result:=WriteFile(FChildStdinWr, chBuf^, BufSize, dwWritten, nil);
 Result:=Result and (BufSize = dwWritten);
end;

function ReadStrFromChild(Timeout:Integer):string;
var
  i: Integer;
  dwRead, BufSize, DesBufSize, dwWritten: DWORD;
  chBuf, buf1:PChar;
  Res:Boolean;
begin
 Result:='';
 try
  BufSize:=0;
  New(chBuf);
  New(buf1);
  repeat
   for i:=0 to 9 do
   begin
    Res:=PeekNamedPipe(FChildStdoutRd, nil, 0, nil, @DesBufSize, nil);
    Res:=Res and (DesBufSize > 0);
    if Res then
    Break;
    Sleep(Round(Timeout / 10));
   end;
   if Res then
   begin
    if DesBufSize<>BufSize then
    begin
     FreeMem(chBuf);
     GetMem(chBuf, DesBufSize);
     FreeMem(buf1);
     GetMem(buf1, DesBufSize);
     BufSize:=DesBufSize;
    end;
    Res:=ReadFile(FChildStdoutRd, chBuf^, BufSize, dwRead, nil);
    StrCopy(buf1, chBuf);
    OemToChar(buf1, buf1);
    Result:=Result+buf1;
   end;
  until not Res;
  FreeMem(chBuf);
  FreeMem(buf1);
 except
  Result:='Read Err';
 end;
end;

procedure TLeastenThread.Execute;
begin
 While (WaitForSingleObject(hProcess, 100)<>WAIT_OBJECT_0) and
  (not Terminated) do
 begin
  buf_out:='';
  buf_out:=ReadStrFromChild(1000);
  If buf_out<>'' then
  Synchronize(DoMemoOut);
  If flag_enter then
  begin
   flag_enter:=False;
   Synchronize(DoMemoIn);
   WriteToChild(buf_in);
  end;
 end;
  buf_out:=ReadStrFromChild(1000);
  If buf_out<>'' then
  Synchronize(DoMemoOut);
end;

procedure TLeastenThread.DoMemoOut;
begin
 Form1.Memo1.Lines.Text:=Form1.Memo1.Lines.Text+buf_out;
end;

procedure TLeastenThread.DoMemoIn;
begin
 buf_in:=Form1.Memo2.Lines.Text;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FChildStdoutRd:=INVALID_HANDLE_VALUE;
 FChildStdoutWr:=INVALID_HANDLE_VALUE;
 FChildStdinRd:=INVALID_HANDLE_VALUE;
 FChildStdinWr:=INVALID_HANDLE_VALUE;

 flag_enter:=False;
 LeastenThread:=nil;
 hProcess:=0;

 sa.nLength := sizeof(sa);
 sa.bInheritHandle := TRUE;
 sa.lpSecurityDescriptor := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 If Assigned(LeastenThread) then
 begin
  LeastenThread.Terminate;
  LeastenThread.WaitFor;
  LeastenThread.Free;

  If hProcess<>0 then
  begin
   TerminateProcess(hProcess, 0);
   hProcess:=0;
  end;
 end;

 flag_enter:=False;

 If FChildStdoutRd<>INVALID_HANDLE_VALUE then
 begin
  CloseHandle(FChildStdoutRd);
  FChildStdoutRd:=INVALID_HANDLE_VALUE;
 end;
 If FChildStdoutWr<>INVALID_HANDLE_VALUE then
 begin
  CloseHandle(FChildStdoutWr);
  FChildStdoutWr:=INVALID_HANDLE_VALUE;
 end;
 If FChildStdinRd<>INVALID_HANDLE_VALUE then
 begin
  CloseHandle(FChildStdinRd);
  FChildStdinRd:=INVALID_HANDLE_VALUE;
 end;
 If FChildStdinWr<>INVALID_HANDLE_VALUE then
 begin
  CloseHandle(FChildStdinWr);
  FChildStdinWr:=INVALID_HANDLE_VALUE;
 end;

 If not CreatePipe(FChildStdoutRd, FChildStdoutWr, @sa, 0) then
 begin
  MessageBox(0, 'CreatePipe failed', '', MB_OK or MB_ICONERROR);
  exit;
 end;
 SetHandleInformation(FChildStdoutRd, HANDLE_FLAG_INHERIT, 0);

 If not CreatePipe(FChildStdinRd, FChildStdinWr, @sa, 0) then
 begin
  MessageBox(0, 'CreatePipe failed', '', MB_OK or MB_ICONERROR);
  exit;
 end;
 SetHandleInformation(FChildStdinWr, HANDLE_FLAG_INHERIT, 0);

 If Edit1.Text='' then
 exit;
 CreateChildProcess(Edit1.Text, hProcess);
 LeastenThread:=TLeastenThread.Create(False);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 flag_enter:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 If Assigned(LeastenThread) then
 begin
  LeastenThread.Terminate;
  LeastenThread.WaitFor;
  LeastenThread.Free;

  If hProcess<>0 then
  begin
   TerminateProcess(hProcess, 0);
   hProcess:=0;
  end;
 end;
end;

end.
